//Просто линейная регрессия
#property  indicator_chart_window
#property  indicator_buffers 1
#property  indicator_color1  Blue
#property  indicator_width1  2
//+------------------------------------------------------------------+
double LinReg[];//рисуемый буфер линейной регрессии
//+------------------------------------------------------------------+
struct DD//Double Double
{
    //Линейная форма a0 + a1*x
	 double 
	   a0,
     a1;
};
//+------------------------------------------------------------------+
extern int M1_period_minute = 60;//в барах
//extern int period = 60;//в барах
int period;
//=====================================================================
int init()
{
  Comment("LinReg");
  Print("Period=",Period());
	 SetIndexBuffer(0,LinReg);
   //SetIndexStyle(0,DRAW_LINE,STYLE_DOT);//
   SetIndexStyle(0,DRAW_LINE);//
   //SetIndexShift(0,period);
   ArrayResize(LinReg, period+1);
   
   period=M1_period_minute/Period();
   Print("TM Period (min) = ",Period(),"; Reg period = ",period);
   if(period<2)
   {
     Print("Warning! Reg period < 2 cannot be shown");
   }

  return(0);
}
//+------------------------------------------------------------------+
int deinit() { Comment(""); return(0); }
//+------------------------------------------------------------------+
int start()
{
  if(period>=2)
  {
    int j;
    //////Линейная регрессия
    DD Par;
    Par = LinPar(period,0);//параметры линии регрессии на периоде от бара 1

    //Отрисовка
    for(j=0;j<=period;j++) LinReg[j] = Line(j, Par.a0, Par.a1);
    LinReg[period+1] = EMPTY_VALUE;//гасим линию слева периода
  }
  return (0); 
}

//+------------------------------------------------------------------+
double Line(double x, double a0, double a1)//регрессионная линия
{//Вычисляет цену в точке x по линейной форме:
	return a0 + a1*x;
}//start()

DD LinPar(int N,int j)
{//N-период - количество баров влево,j-начальный номер бара
   //Возвращает коэффициенты уравнения линии: a0+a1*x в виде
   //структуры DD: struct{double a0,a1;}
	double S0 = N;
	double S1 = S0*(N+1)/2;
	double S2 = S1*(2*N+1)/3;
   
	double B0 = 0, B1 = 0;
   int i;
	for(i = 1; i<=N; i++)
	{
      int k = i+j-1;
      double Pr = (Open[k]+High[k]+Low[k]+Close[k])*0.25;
      B0 += Pr;
      B1 += i*Pr;
	}
	double Delta = S0*S2 - S1*S1;
	double Delta_a0 = B0*S2 - B1*S1;
	double Delta_a1 = B1*S0 - B0*S1;

	DD Out;
	Out.a0 = Delta_a0/Delta;
	Out.a1 = Delta_a1/Delta;

	return Out;
}//LinPar